<template>
  <div>
    <div class="store">
      <div class="store__information">
        <div class="store__top">
          <div v-if="store.type">{{ store.type }}</div>
          <div v-if="store.category">{{ store.category }}</div>
          <div v-if="store.location">
            {{
              [store.location.city, store.location.country]
                .filter(e => !!e)
                .join(', ')
            }}
          </div>
        </div>
        <div class="store__title">{{ store.name }}</div>
        <div v-if="store.description" class="store__descr">
          {{ store.description }}
        </div>
      </div>
      <div class="store__owner">
        <Avatar :user="store.user" :size="100" />
        <div>
          <div class="username">{{ store.user.display_name }}</div>
          <div class="bio">{{ store.user.bio }}</div>
        </div>
      </div>
      <div class="store__booking">
        <div><Button size="inline">Purchase</Button></div>
        <div class="store__price">89$</div>
      </div>
    </div>
    <div class="store-related">
      <div class="store-related__title">Related products</div>
      <StoreGrid>
        <Store v-for="item in related_store" :key="item.id" :data="item" />
      </StoreGrid>
    </div>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  useAsync,
  ref
} from '@nuxtjs/composition-api'
import { StoreFragment } from '@/sdk/types'
import { useGetStoreQuery, useStoreSubscription } from '@/sdk/hooks'

import Button from '@/components/ui/Button.vue'
import Avatar from '@/components/ui/Avatar.vue'

import Store from '@/components/ui/Store.vue'
import StoreGrid from '@/components/ui/StoreGrid.vue'
export default defineComponent({
  name: 'UserStoreItem',
  components: {
    Avatar,
    Button,
    Store,
    StoreGrid
  },
  head: {},
  props: ['data'],
  setup(_, { root }) {
    const { app, route, error } = useContext()
    const { onResult, loading } = useGetStoreQuery({
      id: root.$route.params.id
    })
    const store = useAsync<StoreFragment>(
      () =>
        new Promise(resolve =>
          onResult(result => {
            if (!result?.data?.store) {
              return error({ statusCode: 404 })
            }
            const store = result.data.store
            resolve(store)
          })
        )
    )
    if (process.client) {
      onResult(result => {
        if (!result?.data?.store) {
          return error({ statusCode: 404 })
        }
        store.value = result.data.store
      })
    }

    const { onResult: related_data } = useStoreSubscription({
      userId: store.value?.user.id as any,
      type: { _neq: 'EVENT' as any },
      limit: 3,
      offset: 0
    })
    const related_store = ref<StoreFragment[]>([])

    related_data(result => {
      if (result?.data?.store) {
        related_store.value = result.data.store
      }
    })

    return { store, loading, related_store }
  }
})
</script>

<style lang="scss" scoped>
.store {
  display: grid;
  grid-template-columns: 1fr auto;
  grid-template-areas: 'information user' 'booking booking';
  align-items: center;
  grid-gap: 40px;
  margin-bottom: 70px;
  &__information {
    grid-area: information;
  }
  &__top {
    font: normal normal bold 18px/23px TT Interfaces;
    letter-spacing: 0.9px;
    color: #9badd6;
    text-transform: uppercase;
    font-weight: bold;
    font-size: 18px;
    line-height: 23px;
    display: flex;
    align-items: center;
    margin-bottom: 20px;
    > * {
      padding-right: 10px;
      &:last-child {
        padding-right: 0px;
      }
    }
  }
  &__title {
    letter-spacing: -1.5px;
    color: #ffffff;
    opacity: 1;
    font-size: 60px;
    line-height: 60px;
    font-weight: 900;
    margin-bottom: 25px;
    &:last-child {
      margin-bottom: 0px;
    }
  }
  &__descr {
    color: #9badd6;
    text-align: left;
    letter-spacing: 0px;
    font-size: 24px;
    line-height: 36px;
    max-width: 900px;
  }
  &__owner {
    grid-area: user;
    display: flex;
    align-items: center;
    font-size: 0px;
    > * {
      margin-right: 40px;
      &:last-child {
        margin-right: 0px;
      }
    }
    .username {
      letter-spacing: 0px;
      color: #ffffff;
      font-weight: 500;
      font-size: 40px;
      line-height: 40px;
      margin-bottom: 8px;
    }
    .bio {
      letter-spacing: 0px;
      color: #8591ad;
      font-weight: 500;
      font-size: 24px;
      line-height: 24px;
    }
  }
  &__booking {
    grid-area: booking;
    display: flex;
    align-items: center;
    > * {
      padding-right: 40px;
      &:last-child {
        padding-right: 0px;
      }
    }
  }
  &__price {
    letter-spacing: 0px;
    color: #ffffff;
    font-size: 60px;
    line-height: 78px;
    font-weight: 900;
  }
  &-related {
    &__title {
      margin-bottom: 35px;
      letter-spacing: 0.9px;
      color: #ffffff;
      text-transform: uppercase;
      font-size: 18px;
      line-height: 18px;
      font-weight: bold;
    }
  }
}
</style>
